# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from humanloop import schemas  # noqa: F401


class Usage(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "generation_tokens",
            "prompt_tokens",
            "total_tokens",
        }
        
        class properties:
            prompt_tokens = schemas.IntSchema
            generation_tokens = schemas.IntSchema
            total_tokens = schemas.IntSchema
            __annotations__ = {
                "prompt_tokens": prompt_tokens,
                "generation_tokens": generation_tokens,
                "total_tokens": total_tokens,
            }
    
    generation_tokens: MetaOapg.properties.generation_tokens
    prompt_tokens: MetaOapg.properties.prompt_tokens
    total_tokens: MetaOapg.properties.total_tokens
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["prompt_tokens"]) -> MetaOapg.properties.prompt_tokens: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["generation_tokens"]) -> MetaOapg.properties.generation_tokens: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["total_tokens"]) -> MetaOapg.properties.total_tokens: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["prompt_tokens", "generation_tokens", "total_tokens", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["prompt_tokens"]) -> MetaOapg.properties.prompt_tokens: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["generation_tokens"]) -> MetaOapg.properties.generation_tokens: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["total_tokens"]) -> MetaOapg.properties.total_tokens: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["prompt_tokens", "generation_tokens", "total_tokens", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        generation_tokens: typing.Union[MetaOapg.properties.generation_tokens, decimal.Decimal, int, ],
        prompt_tokens: typing.Union[MetaOapg.properties.prompt_tokens, decimal.Decimal, int, ],
        total_tokens: typing.Union[MetaOapg.properties.total_tokens, decimal.Decimal, int, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Usage':
        return super().__new__(
            cls,
            *args,
            generation_tokens=generation_tokens,
            prompt_tokens=prompt_tokens,
            total_tokens=total_tokens,
            _configuration=_configuration,
            **kwargs,
        )
